
###############################################################################
# Copyright (c) Lawrence Livermore National Security, LLC and other Ascent
# Project developers. See top-level LICENSE AND COPYRIGHT files for dates and
# other details. No copyright assignment is required to contribute to Ascent.
###############################################################################

###############################################################################
# file: ascent_config.mk
###############################################################################
#
# A CMake-generated Make include file Defines the following Make variables:
#
######
#  ASCENT_INCLUDE_FLAGS
#  ASCENT_LIB_FLAGS
#  ASCENT_MPI_LIB_FLAGS
######
#
#
# For use in another Makefile build system
############################################################################


ASCENT_DIR = /usr/local

ASCENT_CONDUIT_DIR = /usr/local

ASCENT_BUILD_SHARED_LIBS = TRUE

# optional built in libs
ASCENT_APCOMP_ENABLED = 
ASCENT_DRAY_ENABLED   = 
ASCENT_VTKH_ENABLED   = 

# thirdparty libs
ASCENT_CALIPER_ENABLED = 
ASCENT_ADIAK_DIR       = 
ASCENT_CALIPER_DIR     = 

ASCENT_RAJA_DIR      = 
ASCENT_UMPIRE_DIR    = 
ASCENT_CAMP_DIR      = 

ASCENT_OCCA_DIR      = 

ASCENT_VTKM_DIR      = 
ASCENT_VTKM_VERSION  = 
ASCENT_MFEM_DIR      = 

ASCENT_FIDES_DIR     = 
ASCENT_ADIOS2_DIR    = 
ASCENT_GENTEN_DIR    = 

ASCENT_BABELFLOW_DIR      = 
ASCENT_PMT_DIR            = 
ASCENT_STREAMSTAT_DIR     = 
ASCENT_TOPOFILEPARSER_DIR = 


ASCENT_OPENMP_LINK_FLAGS = 

ASCENT_MPI_LIBS = /usr/local/lib/libmpi.so /usr/local/lib/libmpicxx.so /usr/local/lib/libmpi.so /usr/local/lib/libmpifort.so /usr/local/lib/libmpi.so

ASCENT_PYTHON_LIBS =
ASCENT_PYTHON_LIB_DIR=

ASCENT_CUDA_LIBS =   

# include vars from conduit_config.mk
include $(ASCENT_CONDUIT_DIR)/share/conduit/conduit_config.mk

# setup rpath helper
ASCENT_LINK_RPATH = -Wl,-rpath,$(ASCENT_DIR)/lib $(CONDUIT_LINK_RPATH)


# two steps are used b/c there are commas in the linker commands
# which will undermine parsing of the makefile

# in some cases full path to python lib is used instead of lib dir
# + lib. For rpath, make sure python lib dir is set otherwise we will
# get a malformed rpath command and the linker will be unhappy.
ifeq ($(ASCENT_PYTHON_LIB_DIR),)
   # not set, do not include config.mk
else
   ASCENT_PYTHON_RPATH_FLAGS_VALUE = -Wl,-rpath,$(ASCENT_PYTHON_LIB_DIR)
endif

ASCENT_RAJA_RPATH_FLAGS_VALUE = -Wl,-rpath,$(ASCENT_RAJA_DIR)/lib
ASCENT_UMPIRE_RPATH_FLAGS_VALUE = -Wl,-rpath,$(ASCENT_UMPIRE_DIR)/lib
ASCENT_CAMP_RPATH_FLAGS_VALUE = -Wl,-rpath,$(ASCENT_CAMP_DIR)/lib
ASCENT_OCCA_RPATH_FLAGS_VALUE = -Wl,-rpath,$(ASCENT_OCCA_DIR)/lib
ASCENT_VTKM_RPATH_FLAGS_VALUE = -Wl,-rpath,$(ASCENT_VTKM_DIR)/lib
ASCENT_MFEM_RPATH_FLAGS_VALUE = -Wl,-rpath,$(ASCENT_MFEM_DIR)/lib
ASCENT_FIDES_RPATH_FLAGS_VALUE = -Wl,-rpath,$(ASCENT_FIDES_DIR)/lib
ASCENT_ADIOS2_RPATH_FLAGS_VALUE = -Wl,-rpath,$(ASCENT_ADIOS2_DIR)/lib
ASCENT_BABELFLOW_RPATH_FLAGS_VALUE = -Wl,-rpath,$(ASCENT_BABELFLOW_DIR)/lib
ASCENT_PMT_RPATH_FLAGS_VALUE = -Wl,-rpath,$(ASCENT_PMT_DIR)/lib
ASCENT_STREAMSTAT_RPATH_FLAGS_VALUE = -Wl,-rpath,$(ASCENT_STREAMSTAT_DIR)/lib
ASCENT_TOPOFILEPARSER_RPATH_FLAGS_VALUE = -Wl,-rpath,$(ASCENT_TOPOFILEPARSER_DIR)/lib
ASCENT_GENTEN_RPATH_FLAGS_VALUE = -Wl,-rpath,$(ASCENT_GENTEN_DIR)/lib
ASCENT_CALIPER_RPATH_FLAGS_VALUE = -Wl,-rpath,$(ASCENT_CALIPER_DIR)/lib
ASCENT_ADIAK_RPATH_FLAGS_VALUE = -Wl,-rpath,$(ASCENT_ADIAK_DIR)/lib

ASCENT_LINK_RPATH += $(if $(ASCENT_PYTHON_LIBS), $(ASCENT_PYTHON_RPATH_FLAGS_VALUE))
ASCENT_LINK_RPATH += $(if $(ASCENT_RAJA_DIR), $(ASCENT_RAJA_RPATH_FLAGS_VALUE))
ASCENT_LINK_RPATH += $(if $(ASCENT_UMPIRE_DIR), $(ASCENT_UMPIRE_RPATH_FLAGS_VALUE))
ASCENT_LINK_RPATH += $(if $(ASCENT_CAMP_DIR), $(ASCENT_CAMP_RPATH_FLAGS_VALUE))
ASCENT_LINK_RPATH += $(if $(ASCENT_OCCA_DIR), $(ASCENT_OCCA_RPATH_FLAGS_VALUE))
ASCENT_LINK_RPATH += $(if $(ASCENT_VTKM_DIR), $(ASCENT_VTKM_RPATH_FLAGS_VALUE))
ASCENT_LINK_RPATH += $(if $(ASCENT_MFEM_DIR), $(ASCENT_MFEM_RPATH_FLAGS_VALUE))
ASCENT_LINK_RPATH += $(if $(ASCENT_FIDES_DIR), $(ASCENT_FIDES_RPATH_FLAGS_VALUE))
ASCENT_LINK_RPATH += $(if $(ASCENT_ADIOS2_DIR), $(ASCENT_ADIOS2_RPATH_FLAGS_VALUE))
ASCENT_LINK_RPATH += $(if $(ASCENT_BABELFLOW_DIR), $(ASCENT_BABELFLOW_RPATH_FLAGS_VALUE))
ASCENT_LINK_RPATH += $(if $(ASCENT_PMT_DIR), $(ASCENT_PMT_RPATH_FLAGS_VALUE))
ASCENT_LINK_RPATH += $(if $(ASCENT_STREAMSTAT_DIR), $(ASCENT_STREAMSTAT_RPATH_FLAGS_VALUE))
ASCENT_LINK_RPATH += $(if $(ASCENT_TOPOFILEPARSER_DIR), $(ASCENT_TOPOFILEPARSER_RPATH_FLAGS_VALUE))
ASCENT_LINK_RPATH += $(if $(ASCENT_GENTEN_DIR), $(ASCENT_GENTEN_RPATH_FLAGS_VALUE))

ASCENT_LINK_RPATH += $(if $(ASCENT_CALIPER_DIR), $(ASCENT_CALIPER_RPATH_FLAGS_VALUE))
ASCENT_LINK_RPATH += $(if $(ASCENT_ADIAK_DIR), $(ASCENT_ADIAK_RPATH_FLAGS_VALUE))


#################
# Linking Flags
#################

#### CUDA
ifeq ($(ASCENT_CUDA_LIBS),)
   # not set, cuda flags will be blank
else
    ASCENT_CUDA_LIB_FLAGS = $(ASCENT_CUDA_LIBS)
endif

##########
# Conduit
##########

# Note: Conduit's conduit_config.mk handles hdf5 and zlib

# For Conduit without MPI
ASCENT_CONDUIT_LIB_FLAGS = $(CONDUIT_LIB_FLAGS)

# For using Conduit build with MPI
ASCENT_CONDUIT_MPI_LIB_FLAGS = $(CONDUIT_MPI_LIB_FLAGS)

##########
# MFEM
##########
# Include make vars from the mfem config.mk file
ifeq ($(ASCENT_MFEM_DIR),)
   # not set, do not include config.mk
else
   include $(ASCENT_MFEM_DIR)/share/mfem/config.mk
endif

# MFEM isn't in the interface, so we don't need include flags
ASCENT_MFEM_LIB_FLAGS = $(if $(ASCENT_MFEM_DIR),-L $(ASCENT_MFEM_DIR)/lib -lmfem $(MFEM_EXT_LIBS))

# if we build mfem w/ mpi support (which we do to support laghos) serial static builds need to
# link mpi, or fail due to unresolved symbols
#
# If mfem was built with MPI support, add ASCENT_MPI_LIBS to avoid errors with static serial builds
ASCENT_MFEM_LIB_FLAGS += $(if $(MFEM_USE_MPI), $(ASCENT_MPI_LIBS) )

##########
# Dray (builtin)
##########
# (builtin lib installed by ascent)
# Include make vars from the dray_config.mk file
ifeq ($(ASCENT_DRAY_ENABLED),TRUE)
   include $(ASCENT_DIR)/share/ascent/dray_config.mk
   ASCENT_LINK_RPATH += $(DRAY_LINK_RPATH)
endif

##########
# VTK-h (builtin)
##########
# (builtin lib installed by ascent)
# Include make vars from the vtkh_config.mk file
ifeq ($(ASCENT_VTKH_ENABLED),TRUE)
   include $(ASCENT_DIR)/share/ascent/vtkh_config.mk
   ASCENT_LINK_RPATH += $(VTKH_LINK_RPATH)

   ifeq ($(ASCENT_CUDA_LIBS),)
      # not set, do not include config.mk
   else
      # bcal objs are only needed for static libs,
      # if ASCENT_BUILD_SHARED_LIBS isn't defined, we have static libs
      ifeq ($(ASCENT_BUILD_SHARED_LIBS),)
         ASCENT_DEVICE_OBJECT = $(ASCENT_DIR)/lib/bcal_vtkm.o
         ASCENT_DEVICE_OBJECT_MPI = $(ASCENT_DIR)/lib/bcal_vtkm_mpi.o
      endif
   endif  
endif

##########
# Rover (builtin)
##########
# (builtin lib installed by ascent, depends on VTK-h)
ifeq ($(ASCENT_VTKH_ENABLED),TRUE)
   ASCENT_ROVER_LIB_FLAGS = -lrover
   ASCENT_ROVER_MPI_LIB_FLAGS = -lrover_mpi 
endif


##########
# RAJA
##########
ASCENT_RAJA_LIB_FLAGS = $(if $(ASCENT_RAJA_DIR),-L $(ASCENT_RAJA_DIR)/lib -lRAJA)

##########
# UMPIRE
##########
ASCENT_UMPIRE_LIB_FLAGS = $(if $(ASCENT_UMPIRE_DIR),-L $(ASCENT_UMPIRE_DIR)/lib -lumpire)

##########
# CAMP
##########
ASCENT_UMPIRE_LIB_FLAGS = $(if $(ASCENT_CAMP_DIR),-L $(ASCENT_CAMP_DIR)/lib -lcamp)

##########
# OCCA
##########
ASCENT_OCCA_LIB_FLAGS = $(if $(ASCENT_OCCA_DIR),-L $(ASCENT_OCCA_DIR)/lib -locca)



##########
# FIDES + ADIOS2 (mpi only)
##########

#!!!!!
# Note: This does not handle ADIOS2 transitive deps, so it may not work for static builds
#!!!!!

ASCENT_FIDES_LIB_FLAGS = $(if $(ASCENT_FIDES_DIR),-L $(ASCENT_FIDES_DIR)/lib -lfides)
ifeq ($(ASCENT_ADIOS2_DIR),)
   # not set, do not include in config.mk
else
    ASCENT_ADIOS2_LIB_FLAGS = -L $(ASCENT_ADIOS2_DIR)/lib \
                                -ladios2_cxx11_mpi \
                                -ladios2_cxx11     \
                                -ladios2_core_mpi  \
                                -ladios2_core   \
                                -ladios2_perfstubs \
                                -ladios2_evpath    \
                                -ladios2_ffs       \
                                -ladios2_atl       \
                                -ladios2_dill
endif


##########
# BABELFLOW + PMT (mpi only)
##########
ASCENT_BABELFLOW_LIB_FLAGS = $(if $(ASCENT_BABELFLOW_DIR),-L $(ASCENT_BABELFLOW_DIR)/lib -lbabelflow_mpi)
ASCENT_PMT_LIB_FLAGS = $(if $(ASCENT_PMT_DIR),-L $(ASCENT_PMT_DIR)/lib -lpmt)
ASCENT_STREAMSTAT_LIB_FLAGS = $(if $(ASCENT_STREAMSTAT_DIR),-L $(ASCENT_STREAMSTAT_DIR)/lib -lStreamingStatistics)
ASCENT_TOPOFILEPARSER_LIB_FLAGS = $(if $(ASCENT_TOPOFILEPARSER_DIR),-L $(ASCENT_OPOFILEPARSERT_DIR)/lib -lTopologyFileParser)


##########
# GENTEN
##########

#!!!!!
# Note: This does not handle Kokkos or BLAS transitive deps, so it may not work for static builds
#!!!!!

ASCENT_GENTEN_LIB_FLAGS = $(if $(ASCENT_GENTEN_DIR),-L $(ASCENT_GENTEN_DIR)/lib -lgt_higher_moments -lgentenlib -lgenten_mathlibs_c)

# -lopenblas (blas lib may change)
# -lkokkoscontainers
# -lkokkoscore


##########
# CALIPER
##########
ASCENT_ADIAK_LIB_FLAGS    = $(if $(ASCENT_ADIAK_DIR),-L $(ASCENT_ADIAK_DIR)/lib -ladiak)
ASCENT_CALIPER_LIB_FLAGS  = $(if $(ASCENT_CALIPER_DIR),-L $(ASCENT_CALIPER_DIR)/lib -lcaliper)

#######################
# Ascent Include Flags
#######################

# vtk, apcomp, and dray are not in ascent interface, they are not needed here

ASCENT_INCLUDE_FLAGS = $(CONDUIT_INCLUDE_FLAGS) \
                       -I $(ASCENT_DIR)/include/ascent


ASCENT_INCLUDE_FLAGS += $(if $(ASCENT_CALIPER_DIR),-I$(ASCENT_CALIPER_DIR)/include)

####################
# Ascent Lib Flags
####################
# if using Ascent without mpi
ASCENT_LIB_FLAGS = $(ASCENT_DEVICE_OBJECT) \
                   -L $(ASCENT_DIR)/lib \
                   -lascent \
                   -lascent_flow \
                   -lascent_lodepng \
                   $(ASCENT_ROVER_LIB_FLAGS) $(DRAY_LIB_FLAGS) $(ASCENT_VTKH_LIB_FLAGS)  $(ASCENT_VTKM_LIB_FLAGS) $(VTKH_LIB_FLAGS) $(ASCENT_CONDUIT_LIB_FLAGS) $(ASCENT_MFEM_LIB_FLAGS) $(ASCENT_RAJA_LIB_FLAGS) $(ASCENT_UMPIRE_LIB_FLAGS) $(ASCENT_CAMP_LIB_FLAGS) $(ASCENT_OCCA_LIB_FLAGS) $(ASCENT_GENTEN_LIB_FLAGS)  $(ASCENT_PYTHON_LIBS) $(ASCENT_CALIPER_LIB_FLAGS) $(ASCENT_ADIAK_LIB_FLAGS) $(ASCENT_OPENMP_LINK_FLAGS) $(ASCENT_CUDA_LIB_FLAGS)

# if using Ascent with mpi and/or cuda with a non-GPU sim
ASCENT_MPI_LIB_FLAGS = $(ASCENT_DEVICE_OBJECT_MPI) \
                       -L $(ASCENT_DIR)/lib \
                       -lascent_mpi \
                       -lascent_flow \
                       -lascent_lodepng \
                       $(ASCENT_ROVER_MPI_LIB_FLAGS) $(DRAY_MPI_LIB_FLAGS) $(ASCENT_VTKH_MPI_LIB_FLAGS)  $(ASCENT_VTKM_LIB_FLAGS) $(VTKH_MPI_LIB_FLAGS) $(ASCENT_CONDUIT_MPI_LIB_FLAGS) $(ASCENT_MFEM_LIB_FLAGS) $(ASCENT_FIDES_LIB_FLAGS) $(ASCENT_ADIOS2_LIB_FLAGS) $(ASCENT_PMT_LIB_FLAGS) $(ASCENT_STREAMSTAT_LIB_FLAGS) $(ASCENT_TOPOFILEPARSER_LIB_FLAGS) $(ASCENT_BABELFLOW_LIB_FLAGS)  $(ASCENT_RAJA_LIB_FLAGS) $(ASCENT_UMPIRE_LIB_FLAGS) $(ASCENT_CAMP_LIB_FLAGS) $(ASCENT_OCCA_LIB_FLAGS) $(ASCENT_GENTEN_LIB_FLAGS) $(ASCENT_PYTHON_LIBS) $(ASCENT_CALIPER_LIB_FLAGS) $(ASCENT_OPENMP_LINK_FLAGS) $(ASCENT_CUDA_LIB_FLAGS)


# if using Ascent with mpi and/or cuda where the linking code
# performs a device link (resolving all cuda symbols)
ASCENT_MPI_CUDA_LIB_FLAGS = -L $(ASCENT_DIR)/lib \
                            -lascent_mpi \
                            -lascent_flow \
                            -lascent_lodepng \
                            $(ASCENT_ROVER_MPI_LIB_FLAGS) $(DRAY_MPI_LIB_FLAGS) $(ASCENT_VTKH_MPI_LIB_FLAGS) $(ASCENT_VTKM_LIB_FLAGS) $(VTKH_MPI_LIB_FLAGS) $(ASCENT_CONDUIT_MPI_LIB_FLAGS) $(ASCENT_MFEM_LIB_FLAGS) $(ASCENT_OCCA_LIB_FLAGS) $(ASCENT_GENTEN_LIB_FLAGS) $(ASCENT_FIDES_LIB_FLAGS) $(ASCENT_ADIOS2_LIB_FLAGS) $(ASCENT_PMT_LIB_FLAGS) $(ASCENT_STREAMSTAT_LIB_FLAGS) $(ASCENT_TOPOFILEPARSER_LIB_FLAGS) $(ASCENT_BABELFLOW_LIB_FLAGS)  $(ASCENT_RAJA_LIB_FLAGS) $(ASCENT_UMPIRE_LIB_FLAGS) $(ASCENT_CAMP_LIB_FLAGS) $(ASCENT_PYTHON_LIBS) $(ASCENT_CALIPER_LIB_FLAGS) $(ASCENT_OPENMP_LINK_FLAGS) $(ASCENT_CUDA_LIB_FLAGS)

